routes/web.php
<?php

use App\Http\Controllers\CategoryController;
use App\Http\Controllers\ProductController;
use App\Http\Controllers\UserController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

Route::prefix('admin')->group(function () {
    Route::get('/', function () {
        return view('admin.home');
    })->name('admin_home');
    Route::resource('products', ProductController::class);
    Route::resource('categories', CategoryController::class);
    Route::resource('users', UserController::class);
});

app/Models/Product.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Product extends Model
{
    use HasFactory;

    protected $fillable = [
        'name',
        'price',
        'description',
        'quantity_in_stock',
    ];

    public function categories()
    {
        return $this->belongsToMany(Category::class, 'products_categories');
    }

    public function images()
    {
        return $this->hasMany(Image::class);
    }
}

app/Http/Controllers/ProductController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\ProductRequest;
use App\Models\Category;
use App\Models\Image;
use App\Models\Product;
use Exception;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Storage;

class ProductController extends Controller
{
    public function pushCategory($categories, $product_id)
    {
        $data = [];
        if (! empty($categories)) {
            foreach ($categories as $item) {
                array_push($data, [
                    'product_id' => $product_id,
                    'category_id' => $item,
                ]);
            }
        }

        return $data;
    }

    public function createImage($file, $product_id)
    {
        $filenameWithExt = $file->getClientOriginalName();
        $filename = pathinfo($filenameWithExt, PATHINFO_FILENAME);
        $extension = $file->getClientOriginalExtension();
        $fileNameToStore = $filename.'_'.time().'.'.$extension;
        Image::create([
            'product_id' => $product_id,
            'product_img' => 'public/products/'.$fileNameToStore,
        ]);
        $path = $file->storeAs('public/products', $fileNameToStore);
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
        $products = Product::paginate(5);

        return view('admin.product.index', ['products' => $products]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
        $categories = Category::all();

        return view('admin.product.create', ['categories' => $categories]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(ProductRequest $request)
    {
        $product = new Product();
        $product->fill($request->all());
        $product->save();
        $product ? session()->flash('message', 'Create successfully !')
            : session()->flash('message', 'Create Failed !');
        $data = $this->pushCategory($request->categories, $product->id);
        DB::table('products_categories')->insert($data);
        if ($request->hasfile('files')) {
            foreach ($request->file('files') as $key => $file) {
                $this->createImage($file, $product->id);
            }
        }
        $categories = Category::all();

        return view('admin.product.create', ['categories' => $categories]);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
        $categories = Category::all();
        $product = Product::find($id);

        return view('admin.product.edit', ['product' => $product, 'categories' => $categories]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(ProductRequest $request, $id)
    {
        $product = Product::find($id)->update([
            'name' => $request->name,
            'price' => $request->price,
            'description' => $request->description,
            'quantity_in_stock' => $request->quantity_in_stock,
        ]);
        $images = Image::where('product_id', $id)->get();
        foreach ($images as $image) {
            Storage::delete($image->product_img);
        }
        Image::where('product_id', $id)->delete();
        if ($request->hasfile('files')) {
            foreach ($request->file('files') as $key => $file) {
                $this->createImage($file, $id);
            }
        }
        DB::table('products_categories')->where('product_id', $id)->delete();
        $data = $this->pushCategory($request->categories, $id);
        DB::table('products_categories')->insert($data);
        $product ? session()->flash('message', 'Update successfully !')
            : session()->flash('message', 'Update Failed !');

        return redirect("admin/products/{$id}");
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        DB::beginTransaction();
        try {
            $images = Image::where('product_id', $id)->get();
            foreach ($images as $image) {
                Storage::delete($image->product_img);
            }
            DB::table('products_categories')->where('product_id', $id)->delete();
            Image::where('product_id', $id)->delete();
            Product::findOrFail($id)->delete();
        } catch (Exception $e) {
            DB::rollback();
            session()->flash('message', 'Delete failed: '.$e->getMessage().' !');

            return redirect('admin/products');
        }
        DB::commit();
        session()->flash('message', 'Delete successfully !');

        return redirect('admin/products');
    }
}

resources/views/admin/product/create.blade.php
@extends('admin.home')
@section('content')

<div class="col-md-12">
  <div class="card mb-4">
    <h5 class="card-header">Create Product</h5>
    @if (Session::has('message'))
    <div class="alert alert-primary m-3">{{ Session::get('message') }}</div>
    @endif
    @if ($errors->any())
    <div class="alert alert-danger m-6">
      <ul class="list-unstyled">
        @foreach ($errors->all() as $error)
        <li>{{ $error }}</li>
        @endforeach
      </ul>
    </div>
    @endif
    <div class="card-body">
      <form action="{{route('products.store')}}" method="post" enctype="multipart/form-data">
        @csrf
        <div class="mb-3">
          <label for="defaultInput" class="form-label">Name</label>
          <input id="defaultInput" class="form-control" type="text" placeholder="Name ..." name="name" />
        </div>
        <div class="mb-3">
          <label for="defaultInput" class="form-label">Price</label>
          <input id="defaultInput" class="form-control" type="number" placeholder="Price ..." name="price" />
        </div>
        <div>
          <label for="exampleFormControlTextarea1" class="form-label">Description</label>
          <textarea class="form-control" id="exampleFormControlTextarea1" placeholder="Description ..." rows="3"
            name="description"></textarea>
        </div>
        <div class="mb-3">
          <label for="defaultInput" class="form-label">Quantity In Stock</label>
          <input id="defaultInput" class="form-control" type="number" placeholder="Quantity ..."
            name="quantity_in_stock" />
        </div>

        <div class="mb-3">
          <label for="exampleFormControlSelect2" class="form-label">Categories</label>
          <select multiple class="form-select" id="exampleFormControlSelect2" aria-label="Multiple select example"
            name="categories[]">
            @foreach ($categories as $category)
            <option value="{{$category->id}}">{{$category->name}}</option>
            @endforeach
          </select>
        </div>

        <div class="mb-3">
          <label for="formFileMultiple" class="form-label">Images</label>
          <input class="form-control" type="file" id="formFileMultiple" multiple name="files[]"
            onchange="loadPreview(this);" />
          <img id="preview_img" src="" class="" />
        </div>
        <button class="btn btn-primary" type="submit">Create</button>
      </form>
    </div>
  </div>
</div>
@endsection
<script type="text/javascript">
  function loadPreview(input, id) {
    id = id || '#preview_img';
    if (input.files && input.files[0]) {
        var reader = new FileReader();
        reader.onload = function (e) {
            $(id).attr('src', e.target.result)
                .width(200)
                .height(150);
        };
        reader.readAsDataURL(input.files[0]);
    }
  }
</script>

resources/views/admin/product/edit.blade.php
@extends('admin.home')
@section('content')

<div class="col-md-12">
  <div class="card mb-4">
    <h5 class="card-header">Update product: {{$product->name}}</h5>
    @if (Session::has('message'))
    <div class="alert alert-primary m-3">{{ Session::get('message') }}</div>
    @endif
    @if ($errors->any())
    <div class="alert alert-danger m-6">
      <ul class="list-unstyled">
        @foreach ($errors->all() as $error)
        <li>{{ $error }}</li>
        @endforeach
      </ul>
    </div>
    @endif
    <div class="card-body">
      <form action="{{route('products.update', $product->id)}}" method="post" enctype="multipart/form-data">
        @csrf
        @method('put')
        <div class="mb-3">
          <label for="defaultInput" class="form-label">Name</label>
          <input id="defaultInput" class="form-control" type="text" placeholder="Name ..." value="{{$product->name}}"
            name="name" />
        </div>
        <div class="mb-3">
          <label for="defaultInput" class="form-label">Price</label>
          <input id="defaultInput" class="form-control" type="number" placeholder="Price ..."
            value="{{$product->price}}" name="price" />
        </div>
        <div>
          <label for="exampleFormControlTextarea1" class="form-label">Description</label>
          <textarea class="form-control" id="exampleFormControlTextarea1" rows="3" name="description"
            placeholder="Description ...">{{ $product->description }}</textarea>
        </div>
        <div class="mb-3">
          <label for="defaultInput" class="form-label">Quantity In Stock</label>
          <input id="defaultInput" class="form-control" type="number" placeholder="Quantity"
            value="{{ $product->quantity_in_stock }}" name="quantity_in_stock" />
        </div>

        <div class="mb-3">
          <label for="exampleFormControlSelect2" class="form-label">Categories</label>
          <select multiple class="form-select" id="exampleFormControlSelect2" aria-label="Multiple select example"
            name="categories[]">
            @foreach ($categories as $category)
            <option value="{{$category->id}}">{{$category->name}}</option>
            @endforeach
          </select>
        </div>

        <div class="mb-3">
          <label for="formFileMultiple" class="form-label">Images</label>
          <input class="form-control" type="file" id="formFileMultiple" multiple name="files[]"
            onchange="loadPreview(this);" />
          <img id="preview_img" src="" class="" />
        </div>
        <button class="btn btn-primary" type="submit">Update</button>
      </form>
    </div>
  </div>
</div>
@endsection
<script type="text/javascript">
  function loadPreview(input, id) {
    id = id || '#preview_img';
    if (input.files && input.files[0]) {
        var reader = new FileReader();
        reader.onload = function (e) {
            $(id).attr('src', e.target.result)
                .width(200)
                .height(150);
        };
        reader.readAsDataURL(input.files[0]);
    }
  }
</script>

resources/views/admin/product/index.blade.php
@extends('admin.home')
@section('content')
<!-- Basic Bootstrap Table -->
<div class="card">
  <h5 class="card-header">Products</h5>
  @if (Session::has('message'))
  <div class="alert alert-primary m-3">{{ Session::get('message') }}</div>
  @endif
  <div class="table-responsive">
    <table class="table">
      <thead>
        <tr>
          <th>Name</th>
          <th>Price</th>
          <th>Description</th>
          <th>Quantity</th>
          <th>Actions</th>
        </tr>
      </thead>
      <tbody class="table-border-bottom-0">
        @foreach ($products as $product)
        <tr>
          <td><i class="fab fa-angular fa-lg text-danger me-3"></i> <strong>{{ $product->name}}</strong></td>
          <td>{{ $product->price}} $</td>
          <td>{{ $product->description}}</td>
          <td>{{ $product->quantity_in_stock}}</td>
          <td>
            <div style="display: flex; justify-content: center;">
              <a href="{{ route('products.show', $product->id) }}">
                <div class="btn btn-info">Edit</div>
              </a>
              <form method="post" action="{{ route('products.destroy', $product->id) }}">
                @method('delete')
                @csrf
                <button onclick="return confirm('Are you sure?')" type="submit" class="btn btn-danger">Delete</button>
              </form>
            </div>
          </td>
        </tr>
        @endforeach
      </tbody>
    </table>
    {!! $products->withQueryString()->links('pagination::bootstrap-5') !!}
  </div>
</div>
<!--/ Basic Bootstrap Table -->
@endsection
<style>
  tr>th,
  td {
    text-align: center;
  }
</style>